Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1705946 - matrix-synapse FTBFS with Python 3.8
Summary: matrix-synapse FTBFS with Python 3.8
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: matrix-synapse
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Jeremy Cline
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1671106
Blocks: F32FTBFS F32FailsToInstall PYTHON38
TreeView+ depends on / blocked
 
Reported: 2019-05-03 09:24 UTC by Miro Hrončok
Modified: 2019-11-17 23:41 UTC (History)
2 users (show)

Fixed In Version: matrix-synapse-1.5.1-1.fc32
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-17 23:41:31 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)
Full log from Copr (deleted)
2019-05-03 09:24 UTC, Miro Hrončok
no flags Details

Description Miro Hrončok 2019-05-03 09:24:57 UTC
Created attachment 1562264 [details]
Full log from Copr

matrix-synapse 0.34.0.1-4.fc31 fails to build on Python 3.8.
The failure might not be Python 3.8 related.

===============================================================================
[FAIL]
Traceback (most recent call last):
  File "/usr/lib64/python3.8/site-packages/twisted/internet/defer.py", line 1418, in _inlineCallbacks
    result = g.send(result)
  File "/builddir/build/BUILD/synapse-0.34.0.1/tests/storage/test__base.py", line 307, in test_double_get
    self.assertEquals(a.func2.cache.cache.pop.call_count, 3)
  File "/usr/lib64/python3.8/site-packages/twisted/trial/_synctest.py", line 432, in assertEqual
    super(_Assertions, self).assertEqual(first, second, msg)
  File "/usr/lib64/python3.8/unittest/case.py", line 895, in assertEqual
    assertion_func(first, second, msg=msg)
  File "/usr/lib64/python3.8/unittest/case.py", line 888, in _baseAssertEqual
    raise self.failureException(msg)
twisted.trial.unittest.FailTest: 4 != 3

tests.storage.test__base.CacheDecoratorTestCase.test_double_get
===============================================================================
[ERROR]
Traceback (most recent call last):
  File "/builddir/build/BUILD/synapse-0.34.0.1/tests/test_metrics.py", line 44, in test_basic
    }, self.get_metrics_from_gauge(gauge))
  File "/builddir/build/BUILD/synapse-0.34.0.1/tests/test_metrics.py", line 76, in get_metrics_from_gauge
    results[r.name] = {
  File "/builddir/build/BUILD/synapse-0.34.0.1/tests/test_metrics.py", line 78, in <dictcomp>
    for _, labels, value in r.samples
builtins.ValueError: too many values to unpack (expected 3)

tests.test_metrics.TestMauLimit.test_basic
-------------------------------------------------------------------------------
Ran 535 tests in 296.330s

FAILED (skips=4, failures=1, errors=1, successes=529)

Full log attached.

Comment 1 Dan Callaghan 2019-06-08 07:23:15 UTC
There is a slight chance this will be fixed when matrix-synapse is upgraded to a more recent version (bug 1671106) although I have not checked. It looks like upstream still only tests against Python 3.6.

Comment 2 Miro Hrončok 2019-07-09 08:17:34 UTC
matrix-synapse	1.0.0-1.fc31:

===============================================================================
[SKIPPED]
Disabled by default because it's slow

tests.test_visibility.FilterEventsForServerTestCase.test_large_room
===============================================================================
[FAIL]
Traceback (most recent call last):
  File "/usr/lib64/python3.8/site-packages/twisted/internet/defer.py", line 1418, in _inlineCallbacks
    result = g.send(result)
  File "/builddir/build/BUILD/synapse-1.0.0/tests/storage/test__base.py", line 308, in test_double_get
    self.assertEquals(a.func2.cache.cache.pop.call_count, 3)
  File "/usr/lib64/python3.8/site-packages/twisted/trial/_synctest.py", line 432, in assertEqual
    super(_Assertions, self).assertEqual(first, second, msg)
  File "/usr/lib64/python3.8/unittest/case.py", line 907, in assertEqual
    assertion_func(first, second, msg=msg)
  File "/usr/lib64/python3.8/unittest/case.py", line 900, in _baseAssertEqual
    raise self.failureException(msg)
twisted.trial.unittest.FailTest: 4 != 3

tests.storage.test__base.CacheDecoratorTestCase.test_double_get
-------------------------------------------------------------------------------
Ran 687 tests in 283.260s

FAILED (skips=1, failures=1, successes=685)

Comment 3 Ben Cotton 2019-08-13 16:47:54 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 4 Miro Hrončok 2019-08-14 22:24:38 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 5 Miro Hrončok 2019-08-21 16:35:23 UTC
The f32-python side tag has been merged. In order to rebuild the package, do it in regular rawhide, but please wait until python3-3.8 is tagged:

  $ koji wait-repo f32-build --build python3-3.8.0~b3-3.fc32


If your built already started in f32-python, after it is finished, please tag it to rawhide with:

  $ koji tag-build f32-pending <nvr>

For example:

  $ koji tag-build f32-pending libreoffice-6.3.0.4-3.fc32

Thanks!

(This comment is mass posted to all bugzillas blocking the PYTHON38 tracking bug.)

Comment 6 Miro Hrončok 2019-08-21 17:29:24 UTC
(Python 3.8 has landed in the rawhide buildroot.)

Comment 7 Miro Hrončok 2019-09-16 07:54:58 UTC
This issue is blocking the Python 3.8 rebuilds. If this package won't build with 3.8, it won't be installable, along with all its dependent packages, in Fedora 32.
Furthermore, as it fails to install, its dependent packages will fail to install and/or build as well.

Could you please look into it?

Comment 8 Dan Callaghan 2019-10-12 04:43:38 UTC
This problem still exists with the latest synapse release (1.4.0) and upstream is still only testing with Python 3.7. The issue hasn't been reported upstream yet as far as I could see, so I filed it:

https://github.com/matrix-org/synapse/issues/6200

Comment 9 Miro Hrončok 2019-11-17 23:41:31 UTC
Thanks for the fix.


Note You need to log in before you can comment on or make changes to this bug.